## cppad 2024.00.00.4

=== CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-23 Bradley M. Bell
# ----------------------------------------------------------------------------
# =============================================================================
# Some constants
# =============================================================================
#
# Set the minimum required version of cmake for this project.
# see http://www.cmake.org/pipermail/cmake/2013-January/053213.html
CMAKE_MINIMUM_REQUIRED(VERSION 3.5)
#
# Only interpret if() arguments as variables or keywords when unquoted.
IF( POLICY CMP0054 )
  CMAKE_POLICY(SET CMP0054 NEW)
ENDIF( POLICY CMP0054 )
#
# cppad_version is used by version.sh to get the version number.
SET(cppad_version "20240000.4")
SET(cppad_url          "https://coin-or.github.io/CppAD" )
SET(cppad_description  "Differentiation of C++ Algorithms" )
IF( NOT DEFINED CMAKE_BUILD_TYPE)
    SET(CMAKE_BUILD_TYPE "NOTFOUND")
ENDIF( NOT DEFINED CMAKE_BUILD_TYPE)
#
# Set name of this project and create the variables
# cppad_BINARY_DIR and cppad_SOURCE_DIR.
# project(projectname [CXX] [C] [Java])
PROJECT(cppad)
#
# Add the include sub-directory to the list of C++ preprocessor
# include directories for the entire project.  The SYSTEM flag is not included
# so warnings will be geenreated for this directory.
INCLUDE_DIRECTORIES( ${cppad_SOURCE_DIR}/include )
#
# =============================================================================
# Some system cmake language extensions
# =============================================================================
# CHECK_CXX_SOURCE_COMPILES(source variable)
# Checks whether the code given in source will compile, link and run and
# return zero status. You can set
# CMAKE_REQUIRED_LIBRARIES, CMAKE_REQUIRED_FLAGS and CMAKE_REQUIRED_INCLUDES
# accordingly if additional libraries or compiler flags are required.
INCLUDE(CheckCXXSourceCompiles)
# ============================================================================
# Some local cmake language
# ============================================================================
# assert_value_in_set(value element_1 ... element_n)
INCLUDE(cmake/assert_value_in_set.cmake)
#
# dos_path_to_unix(dos_path unix_path)
INCLUDE(cmake/dos_path_to_unix.cmake)
#
# add_to_list(variable_list constant_value)
INCLUDE(cmake/add_to_list.cmake)
#
# command_line_arg(variable default type description)
INCLUDE(cmake/command_line_arg.cmake)
#
# prefix_info(package description)
INCLUDE(cmake/prefix_info.cmake)
#
# compile_source_test(source variable)
INCLUDE(cmake/compile_source_test.cmake)
#
# assert(variable)
INCLUDE(cmake/assert.cmake)
#
# print_variable(variable)
INCLUDE(cmake/print_variable.cmake)
#
# set_compile_flags( program_name debug_which source_list)
INCLUDE(cmake/set_compile_flags.cmake)
#
# pkgconfig_info(name, system)
INCLUDE(cmake/pkgconfig_info.cmake)
#
# add_check_executable(parent_target short_name)
INCLUDE(cmake/add_check_executable.cmake)
# =============================================================================
# command line arguments
# =============================================================================
# Arguments that are no longer used
#
IF( debug_which )
   MESSAGE(FATAL_ERROR
      "Using debug_which, use cppad_debug_which or CMAKE_BUILD_TYPE instead"
   )
ENDIF( debug_which )
#
IF( cppad_sparse_list )
   MESSAGE(FATAL_ERROR
      "cppad_sparse_list has been removed from cmake command"
   )
ENDIF( cppad_sparse_list )
#
IF( cppad_deprecated )
   MESSAGE(FATAL_ERROR "cppad_deprecated has been removed from cmake command" )
ENDIF( cppad_deprecated )
#
IF( cmake_install_prefix )
   MESSAGE(FATAL_ERROR
      "cmake_install_prefix has been changed to cppad_prefix"
   )
ENDIF( cmake_install_prefix )
#
IF( cmake_install_postfix )
   MESSAGE(FATAL_ERROR
      "cmake_install_postfix has been changed to cppad_postfix"
   )
ENDIF( cmake_install_postfix )
#
FOREACH(pkg adolc ipopt cppadcg)
   IF( ${pkg}_prefix )
      MESSAGE(FATAL_ERROR
         "-D ${pkg}_prefix=value has been changed to -D include_${pkg}=true"
      )
   ENDIF( ${pkg}_prefix )
ENDFOREACH(pkg adolc eigen ipopt)
#
IF( cmake_needs_dot_slash )
   MESSAGE(FATAL_ERROR
      "cmake_needs_dot_slash was removed; see release notes for 2023-06-01"
   )
ENDIF( cmake_needs_dot_slash )
# -----------------------------------------------------------------------------
# Current Arguments
#
# cmake_install_datadir
command_line_arg(cmake_install_datadir share STRING
   "directory, below prefix, where cmake installs cppad data files"
)
#
# cmake_install_docdir
command_line_arg(cmake_install_docdir NOTFOUND STRING
   "directory, below prefix, where cmake installs cppad documentation files"
)
#
# cmake_install_includedirs
command_line_arg(cmake_install_includedirs include STRING
   "directories, below prefix, where cmake installs include files"
)
#
# cmake_install_libdirs
command_line_arg(cmake_install_libdirs lib STRING
   "directories, below prefix, where cmake installs library files"
)
#
# cmake_defined_ok
command_line_arg(cmake_defined_ok TRUE BOOL
   "If false, check that some symbols only get defined once"
   "If true, you can use CMakeCache.txt to store previous settings"
)
#
# cppad_prefix
command_line_arg(cppad_prefix "${CMAKE_INSTALL_PREFIX}" PATH
   "cppad install prefix"
)
#
# cppad_postfix
command_line_arg(cppad_postfix NOTFOUND STRING
   "cppad install postfix"
)
#
# cppad_cxx_flags
command_line_arg(cppad_cxx_flags "" STRING
   "compile flags used with cppad (besides debug, release, and profile flags)"
)
#
# cppad_profile_flag
command_line_arg(cppad_profile_flag NOTFOUND STRING
   "compile flag used to compile and link a profile version of a program"
)
#
# cppad_testvector
command_line_arg(cppad_testvector cppad STRING
   "Namespace of vector used for testing, one of: boost, cppad, eigen, std"
)
assert_value_in_set(cppad_testvector boost cppad eigen std)
#
# cppad_max_num_threads
command_line_arg(cppad_max_num_threads 48 STRING
   "maximum number of threads that CppAD can use use"
)
IF( "${cppad_max_num_threads}" LESS "4" )
   MESSAGE(FATAL_ERROR
      "cppad_max_num_threads is not an integer greater than or equal 4"
   )
ENDIF( "${cppad_max_num_threads}" LESS "4" )
#
# cppad_tape_id_type
command_line_arg(cppad_tape_id_type "unsigned int" STRING
   "type used to identify different tapes, size must be <= sizeof(size_t)"
)
#
# cppad_tape_addr_type
command_line_arg(cppad_tape_addr_type "unsigned int" STRING
"type used to identify variables on one tape, size must be <= sizeof(size_t)"
)
#
# cppad_static_lib
command_line_arg(cppad_static_lib FALSE BOOL
   "If true (false) the cppad library will be static (shared)"
)
#
# cppad_debug_and_release
command_line_arg(cppad_debug_and_release TRUE BOOL
   "If true the cppad library and tests will be able to mix debug and release"
)
# ----------------------------------------------------------------------------
#
# Ensure c++11 support
SET(CMAKE_REQUIRED_DEFINITIONS "")
SET(CMAKE_REQUIRED_FLAGS       "${cppad_cxx_flags}")
SET(CMAKE_REQUIRED_INCLUDES    "")
SET(CMAKE_REQUIRED_LIBRARIES   "")
SET(source "
int main(void)
{  static_assert( __cplusplus >= 201103 , \"c++11 is supported\" );
   return 0;
}"
)
compile_source_test(${cmake_defined_ok} "${source}" minimal_cplusplus )
IF( NOT minimal_cplusplus  )
   MESSAGE(STATUS "setting C++ standard to 2011")
   SET(CMAKE_CXX_STANDARD 11)
   SET(CMAKE_CXX_STANDARD_REQUIRED ON)
ENDIF( NOT minimal_cplusplus  )
#
# use_cplusplus_2017_ok
SET(source "
int main(void)
{  static_assert( __cplusplus >= 201703 , \"c++17 is supported\" );
   return 0;
}"
)
compile_source_test(${cmake_defined_ok} "${source}" use_cplusplus_2017_ok )
# ----------------------------------------------------------------------------
#
# cppad_debug_and_release_01
IF (cppad_debug_and_release )
   SET(cppad_debug_and_release_01 1 )
ELSE (cppad_debug_and_release )
   SET(cppad_debug_and_release_01 0 )
ENDIF ( )
#
# cppad_debug_which
# CMAKE_BUILD_TYPE
SET(debug_even_or_odd FALSE)
IF( NOT ${cppad_debug_which} STREQUAL "" )
   assert_value_in_set(
      cppad_debug_which debug_even debug_odd debug_all debug_none
   )
ENDIF( NOT ${cppad_debug_which} STREQUAL "" )
IF( CMAKE_BUILD_TYPE )
   IF( NOT ${cppad_debug_which} STREQUAL "" )
      print_variable(CMAKE_BUILD_TYPE)
      print_variable(cppad_debug_which)
      MESSAGE(FATAL_ERROR
         "Both CMAKE_BUILD_TYPE and cppad_debug_which specified"
      )
   ENDIF( )
   STRING( TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower )
   IF(cmake_build_type_lower MATCHES debug)
      SET(cppad_debug_which "debug_all")
   ELSEIF(cmake_build_type_lower MATCHES release)
      SET(cppad_debug_which "debug_none")
   ELSEIF(cmake_build_type_lower MATCHES relwithdebInfo)
      SET(cppad_debug_which "debug_none")
   ELSEIF(cmake_build_type_lower MATCHES minsizerel)
      SET(cppad_debug_which "debug_none")
   ELSE( )
      MESSAGE(FATAL_ERROR
         "Unknonw CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}"
      )
   ENDIF( )
ELSE( ) # CMAKE_BUILD_TYPE
   IF( "${cppad_debug_which}" STREQUAL debug_all)
      SET(CMAKE_BUILD_TYPE Debug)
   ELSEIF( "${cppad_debug_which}" STREQUAL debug_none)
      SET(CMAKE_BUILD_TYPE Release)
   ELSEIF( "${cppad_debug_which}" STREQUAL debug_odd)
      SET(CMAKE_BUILD_TYPE Debug)
      SET(debug_even_or_odd TRUE)
   ELSEIF( "${cppad_debug_which}" STREQUAL debug_even)
      SET(CMAKE_BUILD_TYPE Release)
      SET(debug_even_or_odd TRUE)
   ENDIF( "${cppad_debug_which}" STREQUAL debug_all)
ENDIF( ) # CMAKE_BUILD_TYPE
IF( debug_even_or_odd )
   IF ( NOT cppad_debug_and_release )
      MESSAGE(FATAL_ERROR
"cppad_debug_and_release is false and cppad_debug_wich = ${cppad_debug_which}"
      )
   ENDIF ( NOT cppad_debug_and_release )
   IF( ${CMAKE_SYSTEM_NAME} STREQUAL "Windows" )
      MESSAGE(FATAL_ERROR
      "Cannot have cppad_debug_which equal ${cppad_debug_which} on Windows."
      )
   ENDIF( ${CMAKE_SYSTEM_NAME} STREQUAL "Windows" )
ENDIF( debug_even_or_odd )
print_variable(CMAKE_SYSTEM_NAME)
print_variable(cppad_debug_which)
print_variable(CMAKE_BUILD_TYPE)
MESSAGE(STATUS "make check: avialable")
# -----------------------------------------------------------------------------
# CMAKE_INSTALL_PREFIX
SET(CMAKE_INSTALL_PREFIX "${cppad_prefix}"
   CACHE PATH "value copied from cppad_prefix" FORCE
)
# -----------------------------------------------------------------------------
# Optional package information
SET(system_include TRUE)
#
# eigen
IF( ${include_eigen} )
   pkgconfig_info(eigen ${system_include})
   IF( DEFINED eigen_prefix )
      MESSAGE(FATAL_ERROR "include_eigen is true and eigen_prefix is defined")
   ENDIF( )
ELSE( )
   prefix_info(eigen ${system_include} )
ENDIF( )
#
# adolc
pkgconfig_info(adolc ${system_include})
#
# ipopt
pkgconfig_info(ipopt ${system_include})
#
# colpack_prefix
prefix_info(colpack ${system_include} )
#
# sacado_prefix
prefix_info(sacado ${system_include} )
#
# fadbad_prefix
prefix_info(fadbad ${system_include} )
#
# include_cpapdcg
SET( include_cppadcg FALSE CACHE BOOL "include cppadcg" )
IF( include_cppadcg )
   #
   # cppad_has_cppadcg
   SET(cppad_has_cppadcg 1)
   #
   # Assume bin/get_cppadcg.sh puts include files in this directory
   SET(cppadcg_include_dir "${CMAKE_BINARY_DIR}/prefix/include" )
   print_variable(cppadcg_include_dir)
   INCLUDE_DIRECTORIES( SYSTEM ${cppadcg_include_dir})
ELSE( )
   # cppad_has_cppadcg
   SET(cppad_has_cppadcg 0)
ENDIF( include_cppadcg )
# =============================================================================
# cppad_lib
# Perhaps in the future cppad_lib will depend on cmake header only flag ?
SET( cppad_lib    "cppad_lib" )
LINK_DIRECTORIES( ${cppad_BINARY_DIR}/cppad_lib )
# =============================================================================
# colpack_libs
#
IF( cppad_has_colpack )
   SET( colpack_libs "ColPack" )
ELSE( cppad_has_colpack )

=== example/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build the example directory tests
# Inherit environment from ../CMakeList.txt

# initialize check_example_depends
SET(check_example_depends "")
#
# BEGIN_SORT_THIS_LINE_PLUS_1
ADD_SUBDIRECTORY(abs_normal)
ADD_SUBDIRECTORY(atomic_four)
ADD_SUBDIRECTORY(atomic_three)
ADD_SUBDIRECTORY(atomic_two)
ADD_SUBDIRECTORY(chkpoint_two)
ADD_SUBDIRECTORY(compare_change)
ADD_SUBDIRECTORY(general)
ADD_SUBDIRECTORY(get_started)
ADD_SUBDIRECTORY(graph)
ADD_SUBDIRECTORY(jit)
ADD_SUBDIRECTORY(json)
ADD_SUBDIRECTORY(multi_thread)
ADD_SUBDIRECTORY(optimize)
ADD_SUBDIRECTORY(print_for)
ADD_SUBDIRECTORY(sparse)
ADD_SUBDIRECTORY(utility)
# END_SORT_THIS_LINE_MINUS_1
#
# code_gen_fun examples
IF( cppad_has_cppadcg )
   ADD_SUBDIRECTORY(code_gen_fun)
ENDIF( cppad_has_cppadcg )
#
# ipopt_solve examples
IF( cppad_has_ipopt)
   ADD_SUBDIRECTORY(ipopt_solve)
ENDIF( cppad_has_ipopt)


# Add the check_example target
ADD_CUSTOM_TARGET(check_example "" DEPENDS ${check_example_depends})
MESSAGE(STATUS "make check_example: available")

# Change check depends in parent environment
add_to_list(check_depends check_example)
SET(check_depends "${check_depends}" PARENT_SCOPE)

=== example/code_gen_fun/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
#
# BEGIN_SORT_THIS_LINE_PLUS_2
SET(source_list
   code_gen_fun.cpp
   file.cpp
   function.cpp
   jac_as_fun.cpp
   jacobian.cpp
   sparse_jac_as_fun.cpp
   sparse_jacobian.cpp
)
# END_SORT_THIS_LINE_MINUS_2

set_compile_flags(example_code_gen_fun "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE(example_code_gen_fun EXCLUDE_FROM_ALL ${source_list})

# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(example_code_gen_fun
   ${cppad_lib}
   ${colpack_libs}
)
#
# check_example_code_gen_fun
add_check_executable(check_example code_gen_fun)

=== example/optimize/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build the example/optimize directory tests
#
#
# BEGIN_SORT_THIS_LINE_PLUS_2
SET(source_list
   compare_op.cpp
   conditional_skip.cpp
   cumulative_sum.cpp
   forward_active.cpp
   nest_conditional.cpp
   optimize.cpp
   optimize_twice.cpp
   print_for.cpp
   reverse_active.cpp
)
# END_SORT_THIS_LINE_MINUS_2

set_compile_flags( example_optimize "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE(example_optimize EXCLUDE_FROM_ALL ${source_list})
#
# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(example_optimize
   ${cppad_lib}
   ${colpack_libs}
)
#
# check_example_optimize
add_check_executable(check_example optimize)

=== speed/adolc/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-23 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build the speed/adolc directory tests
# Inherit build type from ../CMakeList.txt

# assert include_adolc is true
assert(include_adolc )


# Adds flags to the compiler command line for sources in the current directory
# and below. This command can be used to add any flags, but it was originally
# intended to add preprocessor definitions.
ADD_DEFINITIONS("-DCPPAD_ADOLC_SPEED")

# Local include directories to search (not in package_prefix/includdir)
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/../src )

# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
SET(source_list ../main.cpp alloc_mat.cpp
   det_lu.cpp
   det_minor.cpp
   mat_mul.cpp
   ode.cpp
   poly.cpp
   sparse_hessian.cpp
   sparse_jacobian.cpp
)
set_compile_flags( speed_adolc "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE( speed_adolc EXCLUDE_FROM_ALL ${source_list} )

# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(speed_adolc
   speed_src
   ${cppad_lib}
   ${adolc_LINK_LIBRARIES}
   ${colpack_libs}
)

# check_speed_adolc
add_check_executable(check_speed adolc "correct 54321 colpack")

=== speed/src/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build the cppad_ipopt/src library
# Inherit build type from ../CMakeList.txt

#  add_library(<name> [STATIC | SHARED | MODULE] [EXCLUDE_FROM_ALL]
#  source1 source2 ... sourceN)
# )
# Make libspeed_src a static library because this is just for testing
# and is not installed (do not have to worry about library search path).
# BEGIN_SORT_THIS_LINE_PLUS_2
SET(source_list
   link_det_lu.cpp
   link_det_minor.cpp
   link_mat_mul.cpp
   link_ode.cpp
   link_poly.cpp
   link_sparse_hessian.cpp
   link_sparse_jacobian.cpp
)
# END_SORT_THIS_LINE_MINUS_2

# 2DO: fix problem with the test
#  ./speed_cppad sparse_hessian 123 colpack
# when speed_cppad is compiled for debugging.
#
set_compile_flags( speed_src "${cppad_debug_which}" "${source_list}" )
#
ADD_LIBRARY(speed_src STATIC EXCLUDE_FROM_ALL ${source_list} )

=== test_more/cppad_for_tmb/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
#
# Name for this text
SET(name cppad_for_tmb)
#
# Add extra compiler flags to cppad_cxx_flags so set_compile_flags uses them.
# This change only affects the cppad_for_tmb tests (NO PARENT_SCOPE).
SET(cppad_cxx_flags "${cppad_cxx_flags} ${OpenMP_CXX_FLAGS} -DCPPAD_FOR_TMB")
#
# BEGIN_SORT_THIS_LINE_PLUS_2
SET(source_list
   ${name}.cpp
   implicit_ctor.cpp
   multi_atomic_three.cpp
   multi_atomic_two.cpp
   multi_chkpoint_one.cpp
   multi_chkpoint_two.cpp
   perfer_reverse.cpp
)
# END_SORT_THIS_LINE_MINUS_2

set_compile_flags(
   test_more_${name} "${cppad_debug_which}" "${source_list}"
)
#
# now that we have the properties, add the executable
ADD_EXECUTABLE( test_more_${name} EXCLUDE_FROM_ALL ${source_list} )
TARGET_LINK_LIBRARIES(test_more_${name} PRIVATE
   ${cppad_lib}
   ${colpack_libs}
   ${OpenMP_CXX_LIBRARIES}
)
#
# Extra flags used by linker for openmp support
SET(CMAKE_EXE_LINKER_FLAGS ${OpenMP_CXX_FLAGS} )
#
# check_test_more_${name}
add_check_executable(check_test_more ${name})

=== test_more/general/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-23 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build the test_more/general tests
#
# adolc_sources
IF( cppad_has_adolc )
   SET(adolc_sources base_adolc.cpp)
ELSE( cppad_has_adolc )
   SET(adolc_sources "")
ENDIF( cppad_has_adolc )
#
# eigen_sources
IF( cppad_has_eigen )
   SET(eigen_sources cppad_eigen.cpp eigen_mat_inv.cpp)
ELSE( cppad_has_eigen )
   SET(eigen_sources "")
ENDIF( cppad_has_eigen )
#
# ipopt_sourced
IF( cppad_has_ipopt )
   SET(ipopt_sources ipopt_solve.cpp)
ELSE( cppad_has_ipopt )
   SET(ipopt_sources "")
ENDIF( cppad_has_ipopt )
#
# BEGIN_SORT_THIS_LINE_PLUS_5
SET(source_list
   ${adolc_sources}
   ${eigen_sources}
   ${ipopt_sources}
   abs_normal.cpp
   acos.cpp
   acosh.cpp
   add.cpp
   add_eq.cpp
   add_zero.cpp
   adfun.cpp
   asin.cpp
   asinh.cpp
   assign.cpp
   atan.cpp
   atan2.cpp
   atanh.cpp
   atomic_four.cpp
   atomic_three.cpp
   azmul.cpp
   base2ad.cpp
   base_alloc.cpp
   bool_sparsity.cpp
   check_simple_vector.cpp
   chkpoint_one.cpp
   chkpoint_two.cpp
   compare.cpp
   compare_change.cpp
   cond_exp.cpp
   cond_exp_ad.cpp
   cond_exp_rev.cpp
   copy.cpp
   cos.cpp
   cosh.cpp
   cpp_graph.cpp
   cppad_vector.cpp
   dbl_epsilon.cpp
   dependency.cpp
   div.cpp
   div_eq.cpp
   div_zero_one.cpp
   erf.cpp
   exp.cpp
   expm1.cpp
   extern_value.cpp
   fabs.cpp
   for_hess.cpp
   for_sparse_hes.cpp
   for_sparse_jac.cpp
   forward.cpp
   forward_dir.cpp
   forward_order.cpp
   from_base.cpp
   fun_check.cpp
   general.cpp
   hes_sparsity.cpp
   jacobian.cpp
   json_graph.cpp
   local/is_pod.cpp
   local/json_lexer.cpp
   local/json_parser.cpp
   local/temp_file.cpp
   local/vector_set.cpp
   log.cpp
   log10.cpp
   log1p.cpp
   mul.cpp
   mul_cond_rev.cpp
   mul_cskip.cpp
   mul_eq.cpp
   mul_level.cpp
   mul_zdouble.cpp
   mul_zero_one.cpp
   near_equal_ext.cpp
   neg.cpp
   new_dynamic.cpp
   num_limits.cpp
   ode_err_control.cpp
   optimize.cpp
   parameter.cpp
   poly.cpp
   pow.cpp
   pow_int.cpp
   print_for.cpp
   rev_sparse_jac.cpp
   rev_two.cpp
   reverse.cpp
   romberg_one.cpp
   rosen_34.cpp
   runge_45.cpp
   simple_vector.cpp
   sin.cpp
   sin_cos.cpp
   sinh.cpp
   sparse_hessian.cpp
   sparse_jac_work.cpp
   sparse_jacobian.cpp
   sparse_sub_hes.cpp
   sparse_vec_ad.cpp
   sqrt.cpp
   std_math.cpp
   sub.cpp
   sub_eq.cpp
   sub_zero.cpp
   subgraph_1.cpp
   subgraph_2.cpp
   subgraph_hes2jac.cpp
   tan.cpp
   to_csrc.cpp
   to_string.cpp
   value.cpp
   vec_ad.cpp
   vec_ad_par.cpp
   vec_unary.cpp
)
# END_SORT_THIS_LINE_MINUS_2
set_compile_flags( test_more_general "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE(test_more_general EXCLUDE_FROM_ALL ${source_list})
#
# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(test_more_general
   ${cppad_lib}
   ${adolc_LINK_LIBRARIES}
   ${ipopt_LINK_LIBRARIES}
   ${colpack_libs}
)
#
# check_test_more_general
add_check_executable(check_test_more general)

=== test_more/deprecated/atomic_two/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-22 Bradley M. Bell
# ----------------------------------------------------------------------------
#
# eigen_sources and CPPAD_HAS_EIGEN
IF( cppad_has_eigen )
ELSE( cppad_has_eigen )
   SET(eigen_sources "")
ENDIF( cppad_has_eigen )
#
# BEGIN_SORT_THIS_LINE_PLUS_2
SET(source_list
   atomic_sparsity.cpp
   atomic_two.cpp
   base2ad.cpp
   for_sparse_hes.cpp
   for_sparse_jac.cpp
   forward.cpp
   get_started.cpp
   mat_mul.cpp
   norm_sq.cpp
   reciprocal.cpp
   rev_sparse_hes.cpp
   rev_sparse_jac.cpp
   reverse.cpp
   set_sparsity.cpp
   tangent.cpp
)
# END_SORT_THIS_LINE_MINUS_2

set_compile_flags(test_more_deprecated_atomic_two
   "${cppad_debug_which}" "${source_list}"
)
#
ADD_EXECUTABLE(test_more_deprecated_atomic_two
   EXCLUDE_FROM_ALL ${source_list}
)
#
# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(test_more_deprecated_atomic_two
   ${cppad_lib}
   ${colpack_libs}
)
#
# check_test_more_deprecated_atomic_two
add_check_executable(check_test_more_deprecated atomic_two)

=== debian/changelog ===
cppad (2024.00.00.4-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:49:21 +0000

cppad (2024.00.00.4-1) unstable; urgency=medium

  * New upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 01 Mar 2024 16:32:04 +0000

cppad (2024.00.00.3-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061907

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 17:41:20 +0000

=== debian/control ===
Source: cppad
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@alioth-lists.debian.net>
Uploaders: Miles Lubin <miles.lubin@gmail.com>,
           Barak A. Pearlmutter <bap@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), cmake, libboost-all-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://projects.coin-or.org/CppAD/
Vcs-Git: https://salsa.debian.org/science-team/cppad.git
Vcs-Browser: https://salsa.debian.org/science-team/cppad

Package: libcppad-lib1456.0t64
Provides: ${t64:Provides}
Replaces: libcppad-lib1456.0
Breaks: libcppad-lib1456.0 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Automatic Differentiation of C++ algorithms, shared library
 CppAD is a package for automatic differentiation (AD) of algorithms
 written in C++.  Given appropriately written C++ code that computes a
 function, CppAD augments it to also compute derivative values.  The
 system uses templates, supports forward and reverse accumulation
 modes, and allows nested derivatives.
 .
 This package contains runtime support, including shared libraries.

Package: libcppad-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libcppad-lib1456.0t64 (= ${binary:Version})
Suggests: libcppad-doc
Description: Automatic Differentiation of C++ algorithms, dev files
 CppAD is a package for automatic differentiation (AD) of algorithms
 written in C++.  Given appropriately written C++ code that computes a
 function, CppAD augments it to also compute derivative values.  The
 system uses templates, supports forward and reverse accumulation
 modes, and allows nested derivatives.
 .
 This package contains development file: C++ headers and development
 libraries.

Package: libcppad-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Automatic Differentiation of C++ algorithms, documentation
 CppAD is a package for automatic differentiation (AD) of algorithms
 written in C++.  Given appropriately written C++ code that computes a
 function, CppAD augments it to also compute derivative values.  The
 system uses templates, supports forward and reverse accumulation
 modes, and allows nested derivatives.
 .
 This package contains documentation.
 .
 (Or did, and would if the documentation source format hadn't changed
 to xrst which Debian cannot yet process, and will again at some point
 in the future. For now, see https://coin-or.github.io/CppAD/doc.)

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake --without autoreconf
# adding --without autotools-dev breaks dh_auto_install (!)

override_dh_autotools-dev_updateconfig:
	@echo "using cmake so no need to fiddle with config.guess or config.sub"

override_dh_autotools-dev_restoreconfig:
	@echo "using cmake so no need to fiddle with config.guess or config.sub"

override_dh_auto_configure:
	dh_auto_configure --					\
		-D CMAKE_BUILD_TYPE=release

# Depending on how the package evolves, it might make sense at some
# point to make these package into build dependencies:
#
#	libadolc-dev
#	libcolpack-dev
#	coinor-libipopt-dev
#	libtrilinos-sacado-dev
#	libeigen3-dev
#
# and to enable them with something like this:
#
# override_dh_auto_configure:
#	dh_auto_configure --		\
#		-D adolc_prefix=/usr	\
#		-D colpack_prefix=/usr	\
#		-D ipopt_prefix=/usr	\
#		-D sacado_prefix=/usr	\
#		-D eigen_prefix=/usr

=== debian/watch ===
# See uscan(1) for format
version=4

https://github.com/coin-or/CppAD/tags \
 .*/(\d\d\d\d)(\d\d)(\d\d)\.(\d+)@ARCHIVE_EXT@

## cppad 2024.00.00.5

=== debian/changelog ===
cppad (2024.00.00.5-1) unstable; urgency=medium

  * New upstream release
  * Bump policy

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 03 Jun 2024 17:00:15 +0100

## cppad 2024.00.00.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,7 @@
 ENDIF( POLICY CMP0054 )
 #
 # cppad_version is used by version.sh to get the version number.
-SET(cppad_version "20240000.4")
+SET(cppad_version "20240000.7")
 SET(cppad_url          "https://coin-or.github.io/CppAD" )
 SET(cppad_description  "Differentiation of C++ Algorithms" )
 IF( NOT DEFINED CMAKE_BUILD_TYPE)

=== include/cppad/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-23 Bradley M. Bell
# ----------------------------------------------------------------------------
# Configure the CppAD include file directory
# -----------------------------------------------------------------------------
# check_match
MACRO(check_match match_variable match_constant output_variable)
   STRING(COMPARE EQUAL ${${match_variable}} ${match_constant} match_flag )
   IF( match_flag )
      SET(${output_variable} 1)
   ELSE( match_flag )
      SET(${output_variable} 0)
   ENDIF( match_flag )
   print_variable(${output_variable})
ENDMACRO(check_match)
# -----------------------------------------------------------------------------
# CMAKE_REQUIRED_name
SET(CMAKE_REQUIRED_DEFINITIONS "")
SET(CMAKE_REQUIRED_FLAGS       "")
SET(CMAKE_REQUIRED_INCLUDES    "")
SET(CMAKE_REQUIRED_LIBRARIES   "")
# -----------------------------------------------------------------------------
# cppad_system_is_darwin
IF( "${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin" )
   SET(cppad_system_is_darwin 1)
ELSE( )
   SET(cppad_system_is_darwin 0)
ENDIF( )
print_variable(cppad_system_is_darwin)
# -----------------------------------------------------------------------------
#
# cppad_c_compiler_cmd
# is the command used to run the C compiler.
STRING(REGEX REPLACE ".*[/\]" "" cppad_c_compiler_cmd "${CMAKE_C_COMPILER}")
print_variable(cppad_c_compiler_cmd)
#
# c_compiler_msvc_clang
STRING(REGEX MATCH ".*[/\]clang-cl.exe" match "${CMAKE_C_COMPILER}" )
IF( "${match}" STREQUAL "${CMAKE_C_COMPILER}"  )
   SET(c_compiler_msvc_clang 1)
ELSE( )
   SET(c_compiler_msvc_clang 0)
ENDIF( )
print_variable(c_compiler_msvc_clang)
#
# cmake_compiler_id_lower
STRING(TOLOWER "${CMAKE_C_COMPILER_ID}" cmake_compiler_id_lower)
#
# cppad_c_compiler_msvc_flags
STRING(FIND "${cmake_compiler_id_lower}" msvc index)
IF( NOT "${index}" EQUAL "-1" )
   SET(cppad_c_compiler_msvc_flags 1)
ELSEIF( ${c_compiler_msvc_clang} )
   SET(cppad_c_compiler_msvc_flags 1)
   #
   STRING(FIND "${cmake_compiler_id_lower}" clang index)
   IF( "${index}" EQUAL "-1" )
      MESSAGE(FATAL_ERROR 
         "Looks like MSVC compatible clang-cl.ext C compiler but"
         "CMAKE_C_COMPILER_ID = ${CMAKE_C_COMPILER_ID}"
      )
   ENDIF( )
ELSE( )
   SET(cppad_c_compiler_msvc_flags 0)
ENDIF( )
print_variable( cppad_c_compiler_msvc_flags )
#
# cppad_c_compiler_gnu_flags
IF( ${c_compiler_msvc_clang} )
   SET(cppad_c_compiler_gnu_flags 0)
ELSE( )
   STRING(FIND "${cmake_compiler_id_lower}" clang clang_index)
   STRING(FIND "${cmake_compiler_id_lower}" gnu    gnu_index)
   IF( "${clang_index}" EQUAL "-1"  AND "${gnu_index}" EQUAL "-1" ) 
      SET(cppad_c_compiler_gnu_flags 0)
   ELSE( )
      SET(cppad_c_compiler_gnu_flags 1)
   ENDIF( )
ENDIF( )
print_variable( cppad_c_compiler_gnu_flags )
# -----------------------------------------------------------------------------
# compiler_has_conversion_warn
SET( clang_or_gnu 0 )
IF( "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" )
   SET(clang_or_gnu 1)
ENDIF( "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" )
IF( "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" )
   SET(clang_or_gnu 1)
ENDIF( "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" )
IF( clang_or_gnu )
   SET(CMAKE_REQUIRED_FLAGS
      "${cppad_cxx_flags} -Wfloat-conversion -Wconversion -Werror"
   )
   #
   SET(source "int main(void) { return 0; }")
   compile_source_test(
      ${cmake_defined_ok} "${source}" compiler_has_conversion_warn
   )
   #
   SET(CMAKE_REQUIRED_FLAGS "")
ELSE( clang_or_gnu )
   SET( compiler_has_conversion_warn 0 )
ENDIF( clang_or_gnu )
# -----------------------------------------------------------------------------
# cppad_boostvector, cppad_cppadvector, cppad_eigenvector, cppad_stdvector
#
check_match(cppad_testvector boost cppad_boostvector)
check_match(cppad_testvector cppad cppad_cppadvector)
check_match(cppad_testvector eigen cppad_eigenvector)
check_match(cppad_testvector std   cppad_stdvector)
IF( NOT cppad_boostvector )
IF( NOT cppad_cppadvector )
IF( NOT cppad_eigenvector )
IF( NOT cppad_stdvector )
MESSAGE(FATAL_ERROR
"cppad_testvector not one of following: boost, cppad, eigen, std."
"This should have been found earlier, please report this as a bug."
)
ENDIF( NOT cppad_stdvector )
ENDIF( NOT cppad_eigenvector )
ENDIF( NOT cppad_cppadvector )
ENDIF( NOT cppad_boostvector )
#
IF( cppad_boostvector )
   # FIND_PACKAGE(Boost) done by ../CMakeLists.txt
   IF( NOT Boost_FOUND )
      MESSAGE(FATAL_ERROR
"cppad_testvector == boost but cannot find boost include files"
      )
   ENDIF( NOT Boost_FOUND )
ENDIF( cppad_boostvector )
#
IF( cppad_eigenvector )
   IF( NOT include_eigen )
      MESSAGE(FATAL_ERROR
"cppad_testvector == eigen but eigen_prefix is not specified"
      )
   ENDIF( NOT include_eigen )
ENDIF( cppad_eigenvector )
# -----------------------------------------------------------------------------
# cppad_has_gettimeofday
#
SET(source "
# include<sys/time.h>
int main(void)
{  struct timeval time;
   gettimeofday(&time, 0);
   return 0;
}"
)
compile_source_test(${cmake_defined_ok} "${source}" cppad_has_gettimeofday)
# -----------------------------------------------------------------------------
# Warn user if the following types are signed:
#  cppad_tape_addr_type, cppad_tape_id_type
FOREACH(cmake_var cppad_tape_id_type cppad_tape_addr_type )
   SET(source "
# include <limits>
# include <cstddef>
int main(void)
{  static_assert(
      ! std::numeric_limits<${${cmake_var}}>::is_signed ,
      \"${cmake_var} is a signed type\"
   );
   return 0;
}
"
   )
   compile_source_test(
      ${cmake_defined_ok} "${source}" ${cmake_var}_is_unsigned
   )
   IF( NOT ${${cmake_var}_is_unsigned} )
      MESSAGE(STATUS
"Warning: using a signed type for ${cmake_var} is for CppAD developers only !"
      )
   ENDIF( NOT ${${cmake_var}_is_unsigned} )
ENDFOREACH( cmake_var )
# -----------------------------------------------------------------------------
# cppad_has_mkstemp
#
SET(source "
# include <stdlib.h>
# if _MSC_VER
# include <io.h>
# else
# include <unistd.h>
# endif

int main(void)
{
   char pattern[] = \"/tmp/fileXXXXXX\";
   int fd = mkstemp(pattern);
   return 0;
}
" )
compile_source_test(${cmake_defined_ok} "${source}" cppad_has_mkstemp )
# -----------------------------------------------------------------------------
# cppad_has_tmpname_s
#
SET(source "
# include <stdio.h>
int main(void)
{  char filename[L_tmpnam_s ];
   if( tmpnam_s(filename, L_tmpnam_s ) != 0 )
      return 1;
   return 0;
}
" )
compile_source_test(${cmake_defined_ok} "${source}" cppad_has_tmpnam_s )
# -----------------------------------------------------------------------------
# cppad_is_same_unsigned_int_size_t
#
SET(source "
# include <cstddef>
# include <type_traits>
int main(void)
{  static_assert(
      std::is_same<unsigned int, size_t>::value ,
      \"message not needed with C++17 or later\"  
   );
   return 0;
}
" )
compile_source_test(
   ${cmake_defined_ok} "${source}" cppad_is_same_unsigned_int_size_t 
)
# -----------------------------------------------------------------------------
# cppad_is_same_tape_addr_type_size_t
#
SET(source "
# include <cstddef>
# include <type_traits>
int main(void)
{  static_assert(
      std::is_same<${cppad_tape_addr_type}, size_t>::value ,
      \"message not needed with C++17 or later\"  
   );
   return 0;
}
" )
compile_source_test(
   ${cmake_defined_ok} "${source}" cppad_is_same_tape_addr_type_size_t 
)
# -----------------------------------------------------------------------------
# cppad_padding_block_t 
#
# See block_t in include/cppad/utility/thread_alloc.hpp before changing this.
SET(source "
# include <cstddef>
int main(void)
{  class block_t {
      size_t extra_; size_t tc_index_; void* next_;
   };
   static_assert(
      sizeof(block_t) % sizeof(double) == 0 ,
      \"message not needed with C++17 or later\"  
   );
   return 0;
}
" )
compile_source_test(
   ${cmake_defined_ok} "${source}" first_block_t_mod_double_zero
)
IF( ${first_block_t_mod_double_zero} )
   SET(cppad_padding_block_t "")
ELSE()
   SET(cppad_padding_block_t "void* note_used_;")
ENDIF()
SET(source "
# include <cstddef>
int main(void)
{  class block_t {
      size_t extra_; size_t tc_index_; void* next_; ${cppad_padding_block_t} 
   };
   static_assert(
      sizeof(block_t) % sizeof(double) == 0 ,
      \"message not needed with C++17 or later\"  
   );
   return 0;
}
" )
compile_source_test(
   ${cmake_defined_ok} "${source}" second_block_t_mod_double_zero
)
assert( second_block_t_mod_double_zero )
# -----------------------------------------------------------------------------
# configure.hpp
CONFIGURE_FILE(
   ${CMAKE_CURRENT_SOURCE_DIR}/configure.hpp.in
   ${CMAKE_CURRENT_SOURCE_DIR}/configure.hpp
)
# -----------------------------------------------------------------------------

=== speed/cppad_jit/CMakeLists.txt ===
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later
# SPDX-FileCopyrightText: Bradley M. Bell <bradbell@seanet.com>
# SPDX-FileContributor: 2003-23 Bradley M. Bell
# ----------------------------------------------------------------------------
# Build the speed/cppad_jit directory tests
# Inherit build type from ../CMakeList.txt

# Adds flags to the compiler command line for sources in the current directory
# and below. This command can be used to add any flags, but it was originally
# intended to add preprocessor definitions.
ADD_DEFINITIONS("-DCPPAD_CPPAD_JIT_SPEED")

# Local include directories to search (not in package_prefix/includdir)
INCLUDE_DIRECTORIES(
   ${CMAKE_CURRENT_SOURCE_DIR}/../src
)

# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
SET(source_list ../main.cpp
   det_lu.cpp
   det_minor.cpp
   mat_mul.cpp
   ode.cpp
   poly.cpp
   sparse_hessian.cpp
   sparse_jacobian.cpp
)
set_compile_flags( speed_cppad_jit "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE( speed_cppad_jit EXCLUDE_FROM_ALL ${source_list} )
#
# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(speed_cppad_jit
   ${cppad_lib}
   ${colpack_libs}
)
# cppad_jit is an include file only library
TARGET_LINK_LIBRARIES(speed_cppad_jit speed_src )

# check_speed_cppad_jit
add_check_executable(check_speed cppad_jit "correct 54321")

=== debian/changelog ===
cppad (2024.00.00.7-1) unstable; urgency=medium

  * New upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 11 Sep 2024 17:08:22 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,11 @@
 Source: cppad
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@alioth-lists.debian.net>
+Maintainer: Debian Science Team <debian-science-maintainers@alioth-lists.debian.net>
 Uploaders: Miles Lubin <miles.lubin@gmail.com>,
            Barak A. Pearlmutter <bap@debian.org>
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), cmake, libboost-all-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://projects.coin-or.org/CppAD/
 Vcs-Git: https://salsa.debian.org/science-team/cppad.git
